package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLArrayObjectUsageATI implements GLEnum {
	STATIC_ATI(0x8760),
	DYNAMIC_ATI(0x8761);
	
	private final int glEnum;

	GLArrayObjectUsageATI(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLArrayObjectUsageATI> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLArrayObjectUsageATI fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x8760 -> STATIC_ATI;
			case 0x8761 -> DYNAMIC_ATI;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLArrayObjectUsageATI");
		};
	}
}