package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLAtomicCounterBufferPName implements GLEnum {
	ATOMIC_COUNTER_BUFFER_REFERENCED_BY_COMPUTE_SHADER(0x90ed),
	ATOMIC_COUNTER_BUFFER_BINDING(0x92c1),
	ATOMIC_COUNTER_BUFFER_DATA_SIZE(0x92c4),
	ATOMIC_COUNTER_BUFFER_ACTIVE_ATOMIC_COUNTERS(0x92c5),
	ATOMIC_COUNTER_BUFFER_ACTIVE_ATOMIC_COUNTER_INDICES(0x92c6),
	ATOMIC_COUNTER_BUFFER_REFERENCED_BY_VERTEX_SHADER(0x92c7),
	ATOMIC_COUNTER_BUFFER_REFERENCED_BY_TESS_CONTROL_SHADER(0x92c8),
	ATOMIC_COUNTER_BUFFER_REFERENCED_BY_TESS_EVALUATION_SHADER(0x92c9),
	ATOMIC_COUNTER_BUFFER_REFERENCED_BY_GEOMETRY_SHADER(0x92ca),
	ATOMIC_COUNTER_BUFFER_REFERENCED_BY_FRAGMENT_SHADER(0x92cb);
	
	private final int glEnum;

	GLAtomicCounterBufferPName(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLAtomicCounterBufferPName> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLAtomicCounterBufferPName fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x90ed -> ATOMIC_COUNTER_BUFFER_REFERENCED_BY_COMPUTE_SHADER;
			case 0x92c1 -> ATOMIC_COUNTER_BUFFER_BINDING;
			case 0x92c4 -> ATOMIC_COUNTER_BUFFER_DATA_SIZE;
			case 0x92c5 -> ATOMIC_COUNTER_BUFFER_ACTIVE_ATOMIC_COUNTERS;
			case 0x92c6 -> ATOMIC_COUNTER_BUFFER_ACTIVE_ATOMIC_COUNTER_INDICES;
			case 0x92c7 -> ATOMIC_COUNTER_BUFFER_REFERENCED_BY_VERTEX_SHADER;
			case 0x92c8 -> ATOMIC_COUNTER_BUFFER_REFERENCED_BY_TESS_CONTROL_SHADER;
			case 0x92c9 -> ATOMIC_COUNTER_BUFFER_REFERENCED_BY_TESS_EVALUATION_SHADER;
			case 0x92ca -> ATOMIC_COUNTER_BUFFER_REFERENCED_BY_GEOMETRY_SHADER;
			case 0x92cb -> ATOMIC_COUNTER_BUFFER_REFERENCED_BY_FRAGMENT_SHADER;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLAtomicCounterBufferPName");
		};
	}
}