package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLBlitFramebufferFilter implements GLEnum {
	NEAREST(0x2600),
	LINEAR(0x2601);
	
	private final int glEnum;

	GLBlitFramebufferFilter(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLBlitFramebufferFilter> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLBlitFramebufferFilter fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x2600 -> NEAREST;
			case 0x2601 -> LINEAR;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLBlitFramebufferFilter");
		};
	}
}