package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLBufferAccess implements GLEnum {
	READ_ONLY(0x88b8),
	WRITE_ONLY(0x88b9),
	READ_WRITE(0x88ba);
	
	private final int glEnum;

	GLBufferAccess(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLBufferAccess> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLBufferAccess fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x88b8 -> READ_ONLY;
			case 0x88b9 -> WRITE_ONLY;
			case 0x88ba -> READ_WRITE;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLBufferAccess");
		};
	}
}