package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLColorPointerType implements GLEnum {
	BYTE(0x1400),
	UNSIGNED_BYTE(0x1401),
	SHORT(0x1402),
	UNSIGNED_SHORT(0x1403),
	INT(0x1404),
	UNSIGNED_INT(0x1405),
	FLOAT(0x1406),
	DOUBLE(0x140a);
	
	private final int glEnum;

	GLColorPointerType(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLColorPointerType> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLColorPointerType fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x1400 -> BYTE;
			case 0x1401 -> UNSIGNED_BYTE;
			case 0x1402 -> SHORT;
			case 0x1403 -> UNSIGNED_SHORT;
			case 0x1404 -> INT;
			case 0x1405 -> UNSIGNED_INT;
			case 0x1406 -> FLOAT;
			case 0x140a -> DOUBLE;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLColorPointerType");
		};
	}
}