package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLCombinerMappingNV implements GLEnum {
	UNSIGNED_IDENTITY_NV(0x8536),
	UNSIGNED_INVERT_NV(0x8537),
	EXPAND_NORMAL_NV(0x8538),
	EXPAND_NEGATE_NV(0x8539),
	HALF_BIAS_NORMAL_NV(0x853a),
	HALF_BIAS_NEGATE_NV(0x853b),
	SIGNED_IDENTITY_NV(0x853c),
	SIGNED_NEGATE_NV(0x853d);
	
	private final int glEnum;

	GLCombinerMappingNV(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLCombinerMappingNV> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLCombinerMappingNV fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x8536 -> UNSIGNED_IDENTITY_NV;
			case 0x8537 -> UNSIGNED_INVERT_NV;
			case 0x8538 -> EXPAND_NORMAL_NV;
			case 0x8539 -> EXPAND_NEGATE_NV;
			case 0x853a -> HALF_BIAS_NORMAL_NV;
			case 0x853b -> HALF_BIAS_NEGATE_NV;
			case 0x853c -> SIGNED_IDENTITY_NV;
			case 0x853d -> SIGNED_NEGATE_NV;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLCombinerMappingNV");
		};
	}
}