package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLCombinerParameterNV implements GLEnum {
	COMBINER_INPUT_NV(0x8542),
	COMBINER_MAPPING_NV(0x8543),
	COMBINER_COMPONENT_USAGE_NV(0x8544);
	
	private final int glEnum;

	GLCombinerParameterNV(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLCombinerParameterNV> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLCombinerParameterNV fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x8542 -> COMBINER_INPUT_NV;
			case 0x8543 -> COMBINER_MAPPING_NV;
			case 0x8544 -> COMBINER_COMPONENT_USAGE_NV;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLCombinerParameterNV");
		};
	}
}