package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLCombinerRegisterNV implements GLEnum {
	TEXTURE0(0x84c0),
	TEXTURE1(0x84c1),
	PRIMARY_COLOR_NV(0x852c),
	SECONDARY_COLOR_NV(0x852d),
	SPARE0_NV(0x852e),
	SPARE1_NV(0x852f),
	DISCARD_NV(0x8530);
	
	private final int glEnum;

	GLCombinerRegisterNV(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLCombinerRegisterNV> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLCombinerRegisterNV fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x84c0 -> TEXTURE0;
			case 0x84c1 -> TEXTURE1;
			case 0x852c -> PRIMARY_COLOR_NV;
			case 0x852d -> SECONDARY_COLOR_NV;
			case 0x852e -> SPARE0_NV;
			case 0x852f -> SPARE1_NV;
			case 0x8530 -> DISCARD_NV;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLCombinerRegisterNV");
		};
	}
}