package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLContainerType implements GLEnum {
	PROGRAM_OBJECT_ARB(0x8b40);
	
	private final int glEnum;

	GLContainerType(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLContainerType> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLContainerType fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x8b40 -> PROGRAM_OBJECT_ARB;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLContainerType");
		};
	}
}