package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLConvolutionTarget implements GLEnum {
	CONVOLUTION_1D(0x8010),
	CONVOLUTION_2D(0x8011);
	
	private final int glEnum;

	GLConvolutionTarget(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLConvolutionTarget> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLConvolutionTarget fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x8010 -> CONVOLUTION_1D;
			case 0x8011 -> CONVOLUTION_2D;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLConvolutionTarget");
		};
	}
}