package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLEvalTargetNV implements GLEnum {
	EVAL_2D_NV(0x86c0),
	EVAL_TRIANGULAR_2D_NV(0x86c1);
	
	private final int glEnum;

	GLEvalTargetNV(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLEvalTargetNV> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLEvalTargetNV fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x86c0 -> EVAL_2D_NV;
			case 0x86c1 -> EVAL_TRIANGULAR_2D_NV;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLEvalTargetNV");
		};
	}
}