package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLFeedBackToken implements GLEnum {
	PASS_THROUGH_TOKEN(0x700),
	POINT_TOKEN(0x701),
	LINE_TOKEN(0x702),
	POLYGON_TOKEN(0x703),
	BITMAP_TOKEN(0x704),
	DRAW_PIXEL_TOKEN(0x705),
	COPY_PIXEL_TOKEN(0x706),
	LINE_RESET_TOKEN(0x707);
	
	private final int glEnum;

	GLFeedBackToken(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLFeedBackToken> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLFeedBackToken fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x700 -> PASS_THROUGH_TOKEN;
			case 0x701 -> POINT_TOKEN;
			case 0x702 -> LINE_TOKEN;
			case 0x703 -> POLYGON_TOKEN;
			case 0x704 -> BITMAP_TOKEN;
			case 0x705 -> DRAW_PIXEL_TOKEN;
			case 0x706 -> COPY_PIXEL_TOKEN;
			case 0x707 -> LINE_RESET_TOKEN;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLFeedBackToken");
		};
	}
}