package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLFogPName implements GLEnum {
	FOG_INDEX(0xb61),
	FOG_DENSITY(0xb62),
	FOG_START(0xb63),
	FOG_END(0xb64),
	FOG_MODE(0xb65),
	FOG_COORD_SRC(0x8450);
	
	private final int glEnum;

	GLFogPName(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLFogPName> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLFogPName fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0xb61 -> FOG_INDEX;
			case 0xb62 -> FOG_DENSITY;
			case 0xb63 -> FOG_START;
			case 0xb64 -> FOG_END;
			case 0xb65 -> FOG_MODE;
			case 0x8450 -> FOG_COORD_SRC;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLFogPName");
		};
	}
}