package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLFragmentShaderConATI implements GLEnum {
	CON_0_ATI(0x8941),
	CON_1_ATI(0x8942),
	CON_2_ATI(0x8943),
	CON_3_ATI(0x8944),
	CON_4_ATI(0x8945),
	CON_5_ATI(0x8946),
	CON_6_ATI(0x8947),
	CON_7_ATI(0x8948),
	CON_8_ATI(0x8949),
	CON_9_ATI(0x894a),
	CON_10_ATI(0x894b),
	CON_11_ATI(0x894c),
	CON_12_ATI(0x894d),
	CON_13_ATI(0x894e),
	CON_14_ATI(0x894f),
	CON_15_ATI(0x8950),
	CON_16_ATI(0x8951),
	CON_17_ATI(0x8952),
	CON_18_ATI(0x8953),
	CON_19_ATI(0x8954),
	CON_20_ATI(0x8955),
	CON_21_ATI(0x8956),
	CON_22_ATI(0x8957),
	CON_23_ATI(0x8958),
	CON_24_ATI(0x8959),
	CON_25_ATI(0x895a),
	CON_26_ATI(0x895b),
	CON_27_ATI(0x895c),
	CON_28_ATI(0x895d),
	CON_29_ATI(0x895e),
	CON_30_ATI(0x895f),
	CON_31_ATI(0x8960);
	
	private final int glEnum;

	GLFragmentShaderConATI(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLFragmentShaderConATI> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLFragmentShaderConATI fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x8941 -> CON_0_ATI;
			case 0x8942 -> CON_1_ATI;
			case 0x8943 -> CON_2_ATI;
			case 0x8944 -> CON_3_ATI;
			case 0x8945 -> CON_4_ATI;
			case 0x8946 -> CON_5_ATI;
			case 0x8947 -> CON_6_ATI;
			case 0x8948 -> CON_7_ATI;
			case 0x8949 -> CON_8_ATI;
			case 0x894a -> CON_9_ATI;
			case 0x894b -> CON_10_ATI;
			case 0x894c -> CON_11_ATI;
			case 0x894d -> CON_12_ATI;
			case 0x894e -> CON_13_ATI;
			case 0x894f -> CON_14_ATI;
			case 0x8950 -> CON_15_ATI;
			case 0x8951 -> CON_16_ATI;
			case 0x8952 -> CON_17_ATI;
			case 0x8953 -> CON_18_ATI;
			case 0x8954 -> CON_19_ATI;
			case 0x8955 -> CON_20_ATI;
			case 0x8956 -> CON_21_ATI;
			case 0x8957 -> CON_22_ATI;
			case 0x8958 -> CON_23_ATI;
			case 0x8959 -> CON_24_ATI;
			case 0x895a -> CON_25_ATI;
			case 0x895b -> CON_26_ATI;
			case 0x895c -> CON_27_ATI;
			case 0x895d -> CON_28_ATI;
			case 0x895e -> CON_29_ATI;
			case 0x895f -> CON_30_ATI;
			case 0x8960 -> CON_31_ATI;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLFragmentShaderConATI");
		};
	}
}