package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLFragmentShaderRegATI implements GLEnum {
	REG_0_ATI(0x8921),
	REG_1_ATI(0x8922),
	REG_2_ATI(0x8923),
	REG_3_ATI(0x8924),
	REG_4_ATI(0x8925),
	REG_5_ATI(0x8926),
	REG_6_ATI(0x8927),
	REG_7_ATI(0x8928),
	REG_8_ATI(0x8929),
	REG_9_ATI(0x892a),
	REG_10_ATI(0x892b),
	REG_11_ATI(0x892c),
	REG_12_ATI(0x892d),
	REG_13_ATI(0x892e),
	REG_14_ATI(0x892f),
	REG_15_ATI(0x8930),
	REG_16_ATI(0x8931),
	REG_17_ATI(0x8932),
	REG_18_ATI(0x8933),
	REG_19_ATI(0x8934),
	REG_20_ATI(0x8935),
	REG_21_ATI(0x8936),
	REG_22_ATI(0x8937),
	REG_23_ATI(0x8938),
	REG_24_ATI(0x8939),
	REG_25_ATI(0x893a),
	REG_26_ATI(0x893b),
	REG_27_ATI(0x893c),
	REG_28_ATI(0x893d),
	REG_29_ATI(0x893e),
	REG_30_ATI(0x893f),
	REG_31_ATI(0x8940);
	
	private final int glEnum;

	GLFragmentShaderRegATI(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLFragmentShaderRegATI> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLFragmentShaderRegATI fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x8921 -> REG_0_ATI;
			case 0x8922 -> REG_1_ATI;
			case 0x8923 -> REG_2_ATI;
			case 0x8924 -> REG_3_ATI;
			case 0x8925 -> REG_4_ATI;
			case 0x8926 -> REG_5_ATI;
			case 0x8927 -> REG_6_ATI;
			case 0x8928 -> REG_7_ATI;
			case 0x8929 -> REG_8_ATI;
			case 0x892a -> REG_9_ATI;
			case 0x892b -> REG_10_ATI;
			case 0x892c -> REG_11_ATI;
			case 0x892d -> REG_12_ATI;
			case 0x892e -> REG_13_ATI;
			case 0x892f -> REG_14_ATI;
			case 0x8930 -> REG_15_ATI;
			case 0x8931 -> REG_16_ATI;
			case 0x8932 -> REG_17_ATI;
			case 0x8933 -> REG_18_ATI;
			case 0x8934 -> REG_19_ATI;
			case 0x8935 -> REG_20_ATI;
			case 0x8936 -> REG_21_ATI;
			case 0x8937 -> REG_22_ATI;
			case 0x8938 -> REG_23_ATI;
			case 0x8939 -> REG_24_ATI;
			case 0x893a -> REG_25_ATI;
			case 0x893b -> REG_26_ATI;
			case 0x893c -> REG_27_ATI;
			case 0x893d -> REG_28_ATI;
			case 0x893e -> REG_29_ATI;
			case 0x893f -> REG_30_ATI;
			case 0x8940 -> REG_31_ATI;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLFragmentShaderRegATI");
		};
	}
}