package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLFrontFaceDirection implements GLEnum {
	CW(0x900),
	CCW(0x901);
	
	private final int glEnum;

	GLFrontFaceDirection(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLFrontFaceDirection> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLFrontFaceDirection fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x900 -> CW;
			case 0x901 -> CCW;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLFrontFaceDirection");
		};
	}
}