package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLGetMultisamplePNameNV implements GLEnum {
	SAMPLE_POSITION(0x8e50),
	PROGRAMMABLE_SAMPLE_LOCATION_ARB(0x9341);
	
	private final int glEnum;

	GLGetMultisamplePNameNV(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLGetMultisamplePNameNV> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLGetMultisamplePNameNV fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x8e50 -> SAMPLE_POSITION;
			case 0x9341 -> PROGRAMMABLE_SAMPLE_LOCATION_ARB;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLGetMultisamplePNameNV");
		};
	}
}