package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLGraphicsResetStatus implements GLEnum {
	NO_ERROR(0x0),
	GUILTY_CONTEXT_RESET(0x8253),
	INNOCENT_CONTEXT_RESET(0x8254),
	UNKNOWN_CONTEXT_RESET(0x8255);
	
	private final int glEnum;

	GLGraphicsResetStatus(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLGraphicsResetStatus> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLGraphicsResetStatus fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x0 -> NO_ERROR;
			case 0x8253 -> GUILTY_CONTEXT_RESET;
			case 0x8254 -> INNOCENT_CONTEXT_RESET;
			case 0x8255 -> UNKNOWN_CONTEXT_RESET;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLGraphicsResetStatus");
		};
	}
}