package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLImageTransformPNameHP implements GLEnum {
	IMAGE_SCALE_X_HP(0x8155),
	IMAGE_SCALE_Y_HP(0x8156),
	IMAGE_TRANSLATE_X_HP(0x8157),
	IMAGE_TRANSLATE_Y_HP(0x8158),
	IMAGE_ROTATE_ANGLE_HP(0x8159),
	IMAGE_ROTATE_ORIGIN_X_HP(0x815a),
	IMAGE_ROTATE_ORIGIN_Y_HP(0x815b),
	IMAGE_MAG_FILTER_HP(0x815c),
	IMAGE_MIN_FILTER_HP(0x815d),
	IMAGE_CUBIC_WEIGHT_HP(0x815e);
	
	private final int glEnum;

	GLImageTransformPNameHP(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLImageTransformPNameHP> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLImageTransformPNameHP fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x8155 -> IMAGE_SCALE_X_HP;
			case 0x8156 -> IMAGE_SCALE_Y_HP;
			case 0x8157 -> IMAGE_TRANSLATE_X_HP;
			case 0x8158 -> IMAGE_TRANSLATE_Y_HP;
			case 0x8159 -> IMAGE_ROTATE_ANGLE_HP;
			case 0x815a -> IMAGE_ROTATE_ORIGIN_X_HP;
			case 0x815b -> IMAGE_ROTATE_ORIGIN_Y_HP;
			case 0x815c -> IMAGE_MAG_FILTER_HP;
			case 0x815d -> IMAGE_MIN_FILTER_HP;
			case 0x815e -> IMAGE_CUBIC_WEIGHT_HP;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLImageTransformPNameHP");
		};
	}
}