package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLInternalFormat implements GLEnum {
	STENCIL_INDEX(0x1901),
	DEPTH_COMPONENT(0x1902),
	RED(0x1903),
	RGB(0x1907),
	RGBA(0x1908),
	R3_G3_B2(0x2a10),
	ALPHA4(0x803b),
	ALPHA8(0x803c),
	ALPHA12(0x803d),
	ALPHA16(0x803e),
	LUMINANCE4(0x803f),
	LUMINANCE8(0x8040),
	LUMINANCE12(0x8041),
	LUMINANCE16(0x8042),
	LUMINANCE4_ALPHA4(0x8043),
	LUMINANCE6_ALPHA2(0x8044),
	LUMINANCE8_ALPHA8(0x8045),
	LUMINANCE12_ALPHA4(0x8046),
	LUMINANCE12_ALPHA12(0x8047),
	LUMINANCE16_ALPHA16(0x8048),
	INTENSITY(0x8049),
	INTENSITY4(0x804a),
	INTENSITY8(0x804b),
	INTENSITY12(0x804c),
	INTENSITY16(0x804d),
	RGB2_EXT(0x804e),
	RGB4(0x804f),
	RGB5(0x8050),
	RGB8(0x8051),
	RGB10(0x8052),
	RGB12(0x8053),
	RGB16(0x8054),
	RGBA2(0x8055),
	RGBA4(0x8056),
	RGB5_A1(0x8057),
	RGBA8(0x8058),
	RGB10_A2(0x8059),
	RGBA12(0x805a),
	RGBA16(0x805b),
	DUAL_ALPHA4_SGIS(0x8110),
	DUAL_ALPHA8_SGIS(0x8111),
	DUAL_ALPHA12_SGIS(0x8112),
	DUAL_ALPHA16_SGIS(0x8113),
	DUAL_LUMINANCE4_SGIS(0x8114),
	DUAL_LUMINANCE8_SGIS(0x8115),
	DUAL_LUMINANCE12_SGIS(0x8116),
	DUAL_LUMINANCE16_SGIS(0x8117),
	DUAL_INTENSITY4_SGIS(0x8118),
	DUAL_INTENSITY8_SGIS(0x8119),
	DUAL_INTENSITY12_SGIS(0x811a),
	DUAL_INTENSITY16_SGIS(0x811b),
	DUAL_LUMINANCE_ALPHA4_SGIS(0x811c),
	DUAL_LUMINANCE_ALPHA8_SGIS(0x811d),
	QUAD_ALPHA4_SGIS(0x811e),
	QUAD_ALPHA8_SGIS(0x811f),
	QUAD_LUMINANCE4_SGIS(0x8120),
	QUAD_LUMINANCE8_SGIS(0x8121),
	QUAD_INTENSITY4_SGIS(0x8122),
	QUAD_INTENSITY8_SGIS(0x8123),
	DEPTH_COMPONENT16(0x81a5),
	DEPTH_COMPONENT24(0x81a6),
	DEPTH_COMPONENT32(0x81a7),
	COMPRESSED_RED(0x8225),
	COMPRESSED_RG(0x8226),
	RG(0x8227),
	R8(0x8229),
	R16(0x822a),
	RG8(0x822b),
	RG16(0x822c),
	R16F(0x822d),
	R32F(0x822e),
	RG16F(0x822f),
	RG32F(0x8230),
	R8I(0x8231),
	R8UI(0x8232),
	R16I(0x8233),
	R16UI(0x8234),
	R32I(0x8235),
	R32UI(0x8236),
	RG8I(0x8237),
	RG8UI(0x8238),
	RG16I(0x8239),
	RG16UI(0x823a),
	RG32I(0x823b),
	RG32UI(0x823c),
	COMPRESSED_RGB_S3TC_DXT1_EXT(0x83f0),
	COMPRESSED_RGBA_S3TC_DXT1_EXT(0x83f1),
	COMPRESSED_RGBA_S3TC_DXT3_ANGLE(0x83f2),
	COMPRESSED_RGBA_S3TC_DXT5_ANGLE(0x83f3),
	COMPRESSED_RGB(0x84ed),
	COMPRESSED_RGBA(0x84ee),
	DEPTH_STENCIL(0x84f9),
	DEPTH_STENCIL_MESA(0x8750),
	RGBA32F(0x8814),
	RGB32F(0x8815),
	RGBA16F(0x881a),
	RGB16F(0x881b),
	DEPTH24_STENCIL8(0x88f0),
	R11F_G11F_B10F(0x8c3a),
	RGB9_E5(0x8c3d),
	SRGB(0x8c40),
	SRGB8(0x8c41),
	SRGB_ALPHA(0x8c42),
	SRGB8_ALPHA8(0x8c43),
	COMPRESSED_SRGB(0x8c48),
	COMPRESSED_SRGB_ALPHA(0x8c49),
	COMPRESSED_SRGB_S3TC_DXT1_EXT(0x8c4c),
	COMPRESSED_SRGB_ALPHA_S3TC_DXT1_EXT(0x8c4d),
	COMPRESSED_SRGB_ALPHA_S3TC_DXT3_EXT(0x8c4e),
	COMPRESSED_SRGB_ALPHA_S3TC_DXT5_EXT(0x8c4f),
	DEPTH_COMPONENT32F(0x8cac),
	DEPTH32F_STENCIL8(0x8cad),
	STENCIL_INDEX1(0x8d46),
	STENCIL_INDEX4(0x8d47),
	STENCIL_INDEX8(0x8d48),
	STENCIL_INDEX16(0x8d49),
	RGB565_OES(0x8d62),
	ETC1_RGB8_OES(0x8d64),
	RGBA32UI(0x8d70),
	RGB32UI(0x8d71),
	ALPHA32UI_EXT(0x8d72),
	INTENSITY32UI_EXT(0x8d73),
	LUMINANCE32UI_EXT(0x8d74),
	LUMINANCE_ALPHA32UI_EXT(0x8d75),
	RGBA16UI(0x8d76),
	RGB16UI(0x8d77),
	ALPHA16UI_EXT(0x8d78),
	INTENSITY16UI_EXT(0x8d79),
	LUMINANCE16UI_EXT(0x8d7a),
	LUMINANCE_ALPHA16UI_EXT(0x8d7b),
	RGBA8UI(0x8d7c),
	RGB8UI(0x8d7d),
	ALPHA8UI_EXT(0x8d7e),
	INTENSITY8UI_EXT(0x8d7f),
	LUMINANCE8UI_EXT(0x8d80),
	LUMINANCE_ALPHA8UI_EXT(0x8d81),
	RGBA32I(0x8d82),
	RGB32I(0x8d83),
	ALPHA32I_EXT(0x8d84),
	INTENSITY32I_EXT(0x8d85),
	LUMINANCE32I_EXT(0x8d86),
	LUMINANCE_ALPHA32I_EXT(0x8d87),
	RGBA16I(0x8d88),
	RGB16I(0x8d89),
	ALPHA16I_EXT(0x8d8a),
	INTENSITY16I_EXT(0x8d8b),
	LUMINANCE16I_EXT(0x8d8c),
	LUMINANCE_ALPHA16I_EXT(0x8d8d),
	RGBA8I(0x8d8e),
	RGB8I(0x8d8f),
	ALPHA8I_EXT(0x8d90),
	INTENSITY8I_EXT(0x8d91),
	LUMINANCE8I_EXT(0x8d92),
	LUMINANCE_ALPHA8I_EXT(0x8d93),
	DEPTH_COMPONENT32F_NV(0x8dab),
	DEPTH32F_STENCIL8_NV(0x8dac),
	COMPRESSED_RED_RGTC1(0x8dbb),
	COMPRESSED_SIGNED_RED_RGTC1(0x8dbc),
	COMPRESSED_RED_GREEN_RGTC2_EXT(0x8dbd),
	COMPRESSED_SIGNED_RED_GREEN_RGTC2_EXT(0x8dbe),
	COMPRESSED_RGBA_BPTC_UNORM(0x8e8c),
	COMPRESSED_SRGB_ALPHA_BPTC_UNORM(0x8e8d),
	COMPRESSED_RGB_BPTC_SIGNED_FLOAT(0x8e8e),
	COMPRESSED_RGB_BPTC_UNSIGNED_FLOAT(0x8e8f),
	R8_SNORM(0x8f94),
	RG8_SNORM(0x8f95),
	RGB8_SNORM(0x8f96),
	RGBA8_SNORM(0x8f97),
	R16_SNORM(0x8f98),
	RG16_SNORM(0x8f99),
	RGB16_SNORM(0x8f9a),
	RGBA16_SNORM(0x8f9b),
	SR8_EXT(0x8fbd),
	SRG8_EXT(0x8fbe),
	RGB10_A2UI(0x906f),
	COMPRESSED_R11_EAC(0x9270),
	COMPRESSED_SIGNED_R11_EAC(0x9271),
	COMPRESSED_RG11_EAC(0x9272),
	COMPRESSED_SIGNED_RG11_EAC(0x9273),
	COMPRESSED_RGB8_ETC2(0x9274),
	COMPRESSED_SRGB8_ETC2(0x9275),
	COMPRESSED_RGB8_PUNCHTHROUGH_ALPHA1_ETC2(0x9276),
	COMPRESSED_SRGB8_PUNCHTHROUGH_ALPHA1_ETC2(0x9277),
	COMPRESSED_RGBA8_ETC2_EAC(0x9278),
	COMPRESSED_SRGB8_ALPHA8_ETC2_EAC(0x9279),
	COMPRESSED_RGBA_ASTC_4x4(0x93b0),
	COMPRESSED_RGBA_ASTC_5x4(0x93b1),
	COMPRESSED_RGBA_ASTC_5x5(0x93b2),
	COMPRESSED_RGBA_ASTC_6x5(0x93b3),
	COMPRESSED_RGBA_ASTC_6x6(0x93b4),
	COMPRESSED_RGBA_ASTC_8x5(0x93b5),
	COMPRESSED_RGBA_ASTC_8x6(0x93b6),
	COMPRESSED_RGBA_ASTC_8x8(0x93b7),
	COMPRESSED_RGBA_ASTC_10x5(0x93b8),
	COMPRESSED_RGBA_ASTC_10x6(0x93b9),
	COMPRESSED_RGBA_ASTC_10x8(0x93ba),
	COMPRESSED_RGBA_ASTC_10x10(0x93bb),
	COMPRESSED_RGBA_ASTC_12x10(0x93bc),
	COMPRESSED_RGBA_ASTC_12x12(0x93bd),
	COMPRESSED_RGBA_ASTC_3x3x3_OES(0x93c0),
	COMPRESSED_RGBA_ASTC_4x3x3_OES(0x93c1),
	COMPRESSED_RGBA_ASTC_4x4x3_OES(0x93c2),
	COMPRESSED_RGBA_ASTC_4x4x4_OES(0x93c3),
	COMPRESSED_RGBA_ASTC_5x4x4_OES(0x93c4),
	COMPRESSED_RGBA_ASTC_5x5x4_OES(0x93c5),
	COMPRESSED_RGBA_ASTC_5x5x5_OES(0x93c6),
	COMPRESSED_RGBA_ASTC_6x5x5_OES(0x93c7),
	COMPRESSED_RGBA_ASTC_6x6x5_OES(0x93c8),
	COMPRESSED_RGBA_ASTC_6x6x6_OES(0x93c9),
	COMPRESSED_SRGB8_ALPHA8_ASTC_4x4(0x93d0),
	COMPRESSED_SRGB8_ALPHA8_ASTC_5x4(0x93d1),
	COMPRESSED_SRGB8_ALPHA8_ASTC_5x5(0x93d2),
	COMPRESSED_SRGB8_ALPHA8_ASTC_6x5(0x93d3),
	COMPRESSED_SRGB8_ALPHA8_ASTC_6x6(0x93d4),
	COMPRESSED_SRGB8_ALPHA8_ASTC_8x5(0x93d5),
	COMPRESSED_SRGB8_ALPHA8_ASTC_8x6(0x93d6),
	COMPRESSED_SRGB8_ALPHA8_ASTC_8x8(0x93d7),
	COMPRESSED_SRGB8_ALPHA8_ASTC_10x5(0x93d8),
	COMPRESSED_SRGB8_ALPHA8_ASTC_10x6(0x93d9),
	COMPRESSED_SRGB8_ALPHA8_ASTC_10x8(0x93da),
	COMPRESSED_SRGB8_ALPHA8_ASTC_10x10(0x93db),
	COMPRESSED_SRGB8_ALPHA8_ASTC_12x10(0x93dc),
	COMPRESSED_SRGB8_ALPHA8_ASTC_12x12(0x93dd),
	COMPRESSED_SRGB8_ALPHA8_ASTC_3x3x3_OES(0x93e0),
	COMPRESSED_SRGB8_ALPHA8_ASTC_4x3x3_OES(0x93e1),
	COMPRESSED_SRGB8_ALPHA8_ASTC_4x4x3_OES(0x93e2),
	COMPRESSED_SRGB8_ALPHA8_ASTC_4x4x4_OES(0x93e3),
	COMPRESSED_SRGB8_ALPHA8_ASTC_5x4x4_OES(0x93e4),
	COMPRESSED_SRGB8_ALPHA8_ASTC_5x5x4_OES(0x93e5),
	COMPRESSED_SRGB8_ALPHA8_ASTC_5x5x5_OES(0x93e6),
	COMPRESSED_SRGB8_ALPHA8_ASTC_6x5x5_OES(0x93e7),
	COMPRESSED_SRGB8_ALPHA8_ASTC_6x6x5_OES(0x93e8),
	COMPRESSED_SRGB8_ALPHA8_ASTC_6x6x6_OES(0x93e9);
	
	private final int glEnum;

	GLInternalFormat(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLInternalFormat> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLInternalFormat fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x1901 -> STENCIL_INDEX;
			case 0x1902 -> DEPTH_COMPONENT;
			case 0x1903 -> RED;
			case 0x1907 -> RGB;
			case 0x1908 -> RGBA;
			case 0x2a10 -> R3_G3_B2;
			case 0x803b -> ALPHA4;
			case 0x803c -> ALPHA8;
			case 0x803d -> ALPHA12;
			case 0x803e -> ALPHA16;
			case 0x803f -> LUMINANCE4;
			case 0x8040 -> LUMINANCE8;
			case 0x8041 -> LUMINANCE12;
			case 0x8042 -> LUMINANCE16;
			case 0x8043 -> LUMINANCE4_ALPHA4;
			case 0x8044 -> LUMINANCE6_ALPHA2;
			case 0x8045 -> LUMINANCE8_ALPHA8;
			case 0x8046 -> LUMINANCE12_ALPHA4;
			case 0x8047 -> LUMINANCE12_ALPHA12;
			case 0x8048 -> LUMINANCE16_ALPHA16;
			case 0x8049 -> INTENSITY;
			case 0x804a -> INTENSITY4;
			case 0x804b -> INTENSITY8;
			case 0x804c -> INTENSITY12;
			case 0x804d -> INTENSITY16;
			case 0x804e -> RGB2_EXT;
			case 0x804f -> RGB4;
			case 0x8050 -> RGB5;
			case 0x8051 -> RGB8;
			case 0x8052 -> RGB10;
			case 0x8053 -> RGB12;
			case 0x8054 -> RGB16;
			case 0x8055 -> RGBA2;
			case 0x8056 -> RGBA4;
			case 0x8057 -> RGB5_A1;
			case 0x8058 -> RGBA8;
			case 0x8059 -> RGB10_A2;
			case 0x805a -> RGBA12;
			case 0x805b -> RGBA16;
			case 0x8110 -> DUAL_ALPHA4_SGIS;
			case 0x8111 -> DUAL_ALPHA8_SGIS;
			case 0x8112 -> DUAL_ALPHA12_SGIS;
			case 0x8113 -> DUAL_ALPHA16_SGIS;
			case 0x8114 -> DUAL_LUMINANCE4_SGIS;
			case 0x8115 -> DUAL_LUMINANCE8_SGIS;
			case 0x8116 -> DUAL_LUMINANCE12_SGIS;
			case 0x8117 -> DUAL_LUMINANCE16_SGIS;
			case 0x8118 -> DUAL_INTENSITY4_SGIS;
			case 0x8119 -> DUAL_INTENSITY8_SGIS;
			case 0x811a -> DUAL_INTENSITY12_SGIS;
			case 0x811b -> DUAL_INTENSITY16_SGIS;
			case 0x811c -> DUAL_LUMINANCE_ALPHA4_SGIS;
			case 0x811d -> DUAL_LUMINANCE_ALPHA8_SGIS;
			case 0x811e -> QUAD_ALPHA4_SGIS;
			case 0x811f -> QUAD_ALPHA8_SGIS;
			case 0x8120 -> QUAD_LUMINANCE4_SGIS;
			case 0x8121 -> QUAD_LUMINANCE8_SGIS;
			case 0x8122 -> QUAD_INTENSITY4_SGIS;
			case 0x8123 -> QUAD_INTENSITY8_SGIS;
			case 0x81a5 -> DEPTH_COMPONENT16;
			case 0x81a6 -> DEPTH_COMPONENT24;
			case 0x81a7 -> DEPTH_COMPONENT32;
			case 0x8225 -> COMPRESSED_RED;
			case 0x8226 -> COMPRESSED_RG;
			case 0x8227 -> RG;
			case 0x8229 -> R8;
			case 0x822a -> R16;
			case 0x822b -> RG8;
			case 0x822c -> RG16;
			case 0x822d -> R16F;
			case 0x822e -> R32F;
			case 0x822f -> RG16F;
			case 0x8230 -> RG32F;
			case 0x8231 -> R8I;
			case 0x8232 -> R8UI;
			case 0x8233 -> R16I;
			case 0x8234 -> R16UI;
			case 0x8235 -> R32I;
			case 0x8236 -> R32UI;
			case 0x8237 -> RG8I;
			case 0x8238 -> RG8UI;
			case 0x8239 -> RG16I;
			case 0x823a -> RG16UI;
			case 0x823b -> RG32I;
			case 0x823c -> RG32UI;
			case 0x83f0 -> COMPRESSED_RGB_S3TC_DXT1_EXT;
			case 0x83f1 -> COMPRESSED_RGBA_S3TC_DXT1_EXT;
			case 0x83f2 -> COMPRESSED_RGBA_S3TC_DXT3_ANGLE;
			case 0x83f3 -> COMPRESSED_RGBA_S3TC_DXT5_ANGLE;
			case 0x84ed -> COMPRESSED_RGB;
			case 0x84ee -> COMPRESSED_RGBA;
			case 0x84f9 -> DEPTH_STENCIL;
			case 0x8750 -> DEPTH_STENCIL_MESA;
			case 0x8814 -> RGBA32F;
			case 0x8815 -> RGB32F;
			case 0x881a -> RGBA16F;
			case 0x881b -> RGB16F;
			case 0x88f0 -> DEPTH24_STENCIL8;
			case 0x8c3a -> R11F_G11F_B10F;
			case 0x8c3d -> RGB9_E5;
			case 0x8c40 -> SRGB;
			case 0x8c41 -> SRGB8;
			case 0x8c42 -> SRGB_ALPHA;
			case 0x8c43 -> SRGB8_ALPHA8;
			case 0x8c48 -> COMPRESSED_SRGB;
			case 0x8c49 -> COMPRESSED_SRGB_ALPHA;
			case 0x8c4c -> COMPRESSED_SRGB_S3TC_DXT1_EXT;
			case 0x8c4d -> COMPRESSED_SRGB_ALPHA_S3TC_DXT1_EXT;
			case 0x8c4e -> COMPRESSED_SRGB_ALPHA_S3TC_DXT3_EXT;
			case 0x8c4f -> COMPRESSED_SRGB_ALPHA_S3TC_DXT5_EXT;
			case 0x8cac -> DEPTH_COMPONENT32F;
			case 0x8cad -> DEPTH32F_STENCIL8;
			case 0x8d46 -> STENCIL_INDEX1;
			case 0x8d47 -> STENCIL_INDEX4;
			case 0x8d48 -> STENCIL_INDEX8;
			case 0x8d49 -> STENCIL_INDEX16;
			case 0x8d62 -> RGB565_OES;
			case 0x8d64 -> ETC1_RGB8_OES;
			case 0x8d70 -> RGBA32UI;
			case 0x8d71 -> RGB32UI;
			case 0x8d72 -> ALPHA32UI_EXT;
			case 0x8d73 -> INTENSITY32UI_EXT;
			case 0x8d74 -> LUMINANCE32UI_EXT;
			case 0x8d75 -> LUMINANCE_ALPHA32UI_EXT;
			case 0x8d76 -> RGBA16UI;
			case 0x8d77 -> RGB16UI;
			case 0x8d78 -> ALPHA16UI_EXT;
			case 0x8d79 -> INTENSITY16UI_EXT;
			case 0x8d7a -> LUMINANCE16UI_EXT;
			case 0x8d7b -> LUMINANCE_ALPHA16UI_EXT;
			case 0x8d7c -> RGBA8UI;
			case 0x8d7d -> RGB8UI;
			case 0x8d7e -> ALPHA8UI_EXT;
			case 0x8d7f -> INTENSITY8UI_EXT;
			case 0x8d80 -> LUMINANCE8UI_EXT;
			case 0x8d81 -> LUMINANCE_ALPHA8UI_EXT;
			case 0x8d82 -> RGBA32I;
			case 0x8d83 -> RGB32I;
			case 0x8d84 -> ALPHA32I_EXT;
			case 0x8d85 -> INTENSITY32I_EXT;
			case 0x8d86 -> LUMINANCE32I_EXT;
			case 0x8d87 -> LUMINANCE_ALPHA32I_EXT;
			case 0x8d88 -> RGBA16I;
			case 0x8d89 -> RGB16I;
			case 0x8d8a -> ALPHA16I_EXT;
			case 0x8d8b -> INTENSITY16I_EXT;
			case 0x8d8c -> LUMINANCE16I_EXT;
			case 0x8d8d -> LUMINANCE_ALPHA16I_EXT;
			case 0x8d8e -> RGBA8I;
			case 0x8d8f -> RGB8I;
			case 0x8d90 -> ALPHA8I_EXT;
			case 0x8d91 -> INTENSITY8I_EXT;
			case 0x8d92 -> LUMINANCE8I_EXT;
			case 0x8d93 -> LUMINANCE_ALPHA8I_EXT;
			case 0x8dab -> DEPTH_COMPONENT32F_NV;
			case 0x8dac -> DEPTH32F_STENCIL8_NV;
			case 0x8dbb -> COMPRESSED_RED_RGTC1;
			case 0x8dbc -> COMPRESSED_SIGNED_RED_RGTC1;
			case 0x8dbd -> COMPRESSED_RED_GREEN_RGTC2_EXT;
			case 0x8dbe -> COMPRESSED_SIGNED_RED_GREEN_RGTC2_EXT;
			case 0x8e8c -> COMPRESSED_RGBA_BPTC_UNORM;
			case 0x8e8d -> COMPRESSED_SRGB_ALPHA_BPTC_UNORM;
			case 0x8e8e -> COMPRESSED_RGB_BPTC_SIGNED_FLOAT;
			case 0x8e8f -> COMPRESSED_RGB_BPTC_UNSIGNED_FLOAT;
			case 0x8f94 -> R8_SNORM;
			case 0x8f95 -> RG8_SNORM;
			case 0x8f96 -> RGB8_SNORM;
			case 0x8f97 -> RGBA8_SNORM;
			case 0x8f98 -> R16_SNORM;
			case 0x8f99 -> RG16_SNORM;
			case 0x8f9a -> RGB16_SNORM;
			case 0x8f9b -> RGBA16_SNORM;
			case 0x8fbd -> SR8_EXT;
			case 0x8fbe -> SRG8_EXT;
			case 0x906f -> RGB10_A2UI;
			case 0x9270 -> COMPRESSED_R11_EAC;
			case 0x9271 -> COMPRESSED_SIGNED_R11_EAC;
			case 0x9272 -> COMPRESSED_RG11_EAC;
			case 0x9273 -> COMPRESSED_SIGNED_RG11_EAC;
			case 0x9274 -> COMPRESSED_RGB8_ETC2;
			case 0x9275 -> COMPRESSED_SRGB8_ETC2;
			case 0x9276 -> COMPRESSED_RGB8_PUNCHTHROUGH_ALPHA1_ETC2;
			case 0x9277 -> COMPRESSED_SRGB8_PUNCHTHROUGH_ALPHA1_ETC2;
			case 0x9278 -> COMPRESSED_RGBA8_ETC2_EAC;
			case 0x9279 -> COMPRESSED_SRGB8_ALPHA8_ETC2_EAC;
			case 0x93b0 -> COMPRESSED_RGBA_ASTC_4x4;
			case 0x93b1 -> COMPRESSED_RGBA_ASTC_5x4;
			case 0x93b2 -> COMPRESSED_RGBA_ASTC_5x5;
			case 0x93b3 -> COMPRESSED_RGBA_ASTC_6x5;
			case 0x93b4 -> COMPRESSED_RGBA_ASTC_6x6;
			case 0x93b5 -> COMPRESSED_RGBA_ASTC_8x5;
			case 0x93b6 -> COMPRESSED_RGBA_ASTC_8x6;
			case 0x93b7 -> COMPRESSED_RGBA_ASTC_8x8;
			case 0x93b8 -> COMPRESSED_RGBA_ASTC_10x5;
			case 0x93b9 -> COMPRESSED_RGBA_ASTC_10x6;
			case 0x93ba -> COMPRESSED_RGBA_ASTC_10x8;
			case 0x93bb -> COMPRESSED_RGBA_ASTC_10x10;
			case 0x93bc -> COMPRESSED_RGBA_ASTC_12x10;
			case 0x93bd -> COMPRESSED_RGBA_ASTC_12x12;
			case 0x93c0 -> COMPRESSED_RGBA_ASTC_3x3x3_OES;
			case 0x93c1 -> COMPRESSED_RGBA_ASTC_4x3x3_OES;
			case 0x93c2 -> COMPRESSED_RGBA_ASTC_4x4x3_OES;
			case 0x93c3 -> COMPRESSED_RGBA_ASTC_4x4x4_OES;
			case 0x93c4 -> COMPRESSED_RGBA_ASTC_5x4x4_OES;
			case 0x93c5 -> COMPRESSED_RGBA_ASTC_5x5x4_OES;
			case 0x93c6 -> COMPRESSED_RGBA_ASTC_5x5x5_OES;
			case 0x93c7 -> COMPRESSED_RGBA_ASTC_6x5x5_OES;
			case 0x93c8 -> COMPRESSED_RGBA_ASTC_6x6x5_OES;
			case 0x93c9 -> COMPRESSED_RGBA_ASTC_6x6x6_OES;
			case 0x93d0 -> COMPRESSED_SRGB8_ALPHA8_ASTC_4x4;
			case 0x93d1 -> COMPRESSED_SRGB8_ALPHA8_ASTC_5x4;
			case 0x93d2 -> COMPRESSED_SRGB8_ALPHA8_ASTC_5x5;
			case 0x93d3 -> COMPRESSED_SRGB8_ALPHA8_ASTC_6x5;
			case 0x93d4 -> COMPRESSED_SRGB8_ALPHA8_ASTC_6x6;
			case 0x93d5 -> COMPRESSED_SRGB8_ALPHA8_ASTC_8x5;
			case 0x93d6 -> COMPRESSED_SRGB8_ALPHA8_ASTC_8x6;
			case 0x93d7 -> COMPRESSED_SRGB8_ALPHA8_ASTC_8x8;
			case 0x93d8 -> COMPRESSED_SRGB8_ALPHA8_ASTC_10x5;
			case 0x93d9 -> COMPRESSED_SRGB8_ALPHA8_ASTC_10x6;
			case 0x93da -> COMPRESSED_SRGB8_ALPHA8_ASTC_10x8;
			case 0x93db -> COMPRESSED_SRGB8_ALPHA8_ASTC_10x10;
			case 0x93dc -> COMPRESSED_SRGB8_ALPHA8_ASTC_12x10;
			case 0x93dd -> COMPRESSED_SRGB8_ALPHA8_ASTC_12x12;
			case 0x93e0 -> COMPRESSED_SRGB8_ALPHA8_ASTC_3x3x3_OES;
			case 0x93e1 -> COMPRESSED_SRGB8_ALPHA8_ASTC_4x3x3_OES;
			case 0x93e2 -> COMPRESSED_SRGB8_ALPHA8_ASTC_4x4x3_OES;
			case 0x93e3 -> COMPRESSED_SRGB8_ALPHA8_ASTC_4x4x4_OES;
			case 0x93e4 -> COMPRESSED_SRGB8_ALPHA8_ASTC_5x4x4_OES;
			case 0x93e5 -> COMPRESSED_SRGB8_ALPHA8_ASTC_5x5x4_OES;
			case 0x93e6 -> COMPRESSED_SRGB8_ALPHA8_ASTC_5x5x5_OES;
			case 0x93e7 -> COMPRESSED_SRGB8_ALPHA8_ASTC_6x5x5_OES;
			case 0x93e8 -> COMPRESSED_SRGB8_ALPHA8_ASTC_6x6x5_OES;
			case 0x93e9 -> COMPRESSED_SRGB8_ALPHA8_ASTC_6x6x6_OES;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLInternalFormat");
		};
	}
}