package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLLightModelColorControl implements GLEnum {
	SINGLE_COLOR(0x81f9),
	SEPARATE_SPECULAR_COLOR(0x81fa);
	
	private final int glEnum;

	GLLightModelColorControl(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLLightModelColorControl> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLLightModelColorControl fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x81f9 -> SINGLE_COLOR;
			case 0x81fa -> SEPARATE_SPECULAR_COLOR;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLLightModelColorControl");
		};
	}
}