package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLLightTextureModeEXT implements GLEnum {
	FRAGMENT_MATERIAL_EXT(0x8349),
	FRAGMENT_NORMAL_EXT(0x834a),
	FRAGMENT_COLOR_EXT(0x834c),
	FRAGMENT_DEPTH(0x8452);
	
	private final int glEnum;

	GLLightTextureModeEXT(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLLightTextureModeEXT> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLLightTextureModeEXT fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x8349 -> FRAGMENT_MATERIAL_EXT;
			case 0x834a -> FRAGMENT_NORMAL_EXT;
			case 0x834c -> FRAGMENT_COLOR_EXT;
			case 0x8452 -> FRAGMENT_DEPTH;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLLightTextureModeEXT");
		};
	}
}