package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLMemoryObjectParameterName implements GLEnum {
	DEDICATED_MEMORY_OBJECT_EXT(0x9581),
	PROTECTED_MEMORY_OBJECT_EXT(0x959b);
	
	private final int glEnum;

	GLMemoryObjectParameterName(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLMemoryObjectParameterName> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLMemoryObjectParameterName fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x9581 -> DEDICATED_MEMORY_OBJECT_EXT;
			case 0x959b -> PROTECTED_MEMORY_OBJECT_EXT;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLMemoryObjectParameterName");
		};
	}
}