package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLPathColor implements GLEnum {
	PRIMARY_COLOR_NV(0x852c),
	SECONDARY_COLOR_NV(0x852d),
	PRIMARY_COLOR(0x8577);
	
	private final int glEnum;

	GLPathColor(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLPathColor> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLPathColor fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x852c -> PRIMARY_COLOR_NV;
			case 0x852d -> SECONDARY_COLOR_NV;
			case 0x8577 -> PRIMARY_COLOR;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLPathColor");
		};
	}
}