package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLPathFillMode implements GLEnum {
	INVERT(0x150a),
	PATH_FILL_MODE_NV(0x9080),
	COUNT_UP_NV(0x9088),
	COUNT_DOWN_NV(0x9089);
	
	private final int glEnum;

	GLPathFillMode(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLPathFillMode> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLPathFillMode fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x150a -> INVERT;
			case 0x9080 -> PATH_FILL_MODE_NV;
			case 0x9088 -> COUNT_UP_NV;
			case 0x9089 -> COUNT_DOWN_NV;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLPathFillMode");
		};
	}
}