package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLPixelTexGenModeSGIX implements GLEnum {
	NONE(0x0),
	ALPHA(0x1906),
	RGB(0x1907),
	RGBA(0x1908),
	PIXEL_TEX_GEN_Q_CEILING_SGIX(0x8184),
	PIXEL_TEX_GEN_Q_ROUND_SGIX(0x8185),
	PIXEL_TEX_GEN_Q_FLOOR_SGIX(0x8186),
	PIXEL_TEX_GEN_ALPHA_LS_SGIX(0x8189),
	PIXEL_TEX_GEN_ALPHA_MS_SGIX(0x818a);
	
	private final int glEnum;

	GLPixelTexGenModeSGIX(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLPixelTexGenModeSGIX> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLPixelTexGenModeSGIX fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x0 -> NONE;
			case 0x1906 -> ALPHA;
			case 0x1907 -> RGB;
			case 0x1908 -> RGBA;
			case 0x8184 -> PIXEL_TEX_GEN_Q_CEILING_SGIX;
			case 0x8185 -> PIXEL_TEX_GEN_Q_ROUND_SGIX;
			case 0x8186 -> PIXEL_TEX_GEN_Q_FLOOR_SGIX;
			case 0x8189 -> PIXEL_TEX_GEN_ALPHA_LS_SGIX;
			case 0x818a -> PIXEL_TEX_GEN_ALPHA_MS_SGIX;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLPixelTexGenModeSGIX");
		};
	}
}