package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLPreserveModeATI implements GLEnum {
	PRESERVE_ATI(0x8762),
	DISCARD_ATI(0x8763);
	
	private final int glEnum;

	GLPreserveModeATI(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLPreserveModeATI> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLPreserveModeATI fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x8762 -> PRESERVE_ATI;
			case 0x8763 -> DISCARD_ATI;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLPreserveModeATI");
		};
	}
}