package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLProgramTarget implements GLEnum {
	TEXT_FRAGMENT_SHADER_ATI(0x8200),
	VERTEX_PROGRAM_ARB(0x8620),
	FRAGMENT_PROGRAM_ARB(0x8804),
	TESS_CONTROL_PROGRAM_NV(0x891e),
	TESS_EVALUATION_PROGRAM_NV(0x891f),
	GEOMETRY_PROGRAM_NV(0x8c26),
	COMPUTE_PROGRAM_NV(0x90fb);
	
	private final int glEnum;

	GLProgramTarget(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLProgramTarget> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLProgramTarget fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x8200 -> TEXT_FRAGMENT_SHADER_ATI;
			case 0x8620 -> VERTEX_PROGRAM_ARB;
			case 0x8804 -> FRAGMENT_PROGRAM_ARB;
			case 0x891e -> TESS_CONTROL_PROGRAM_NV;
			case 0x891f -> TESS_EVALUATION_PROGRAM_NV;
			case 0x8c26 -> GEOMETRY_PROGRAM_NV;
			case 0x90fb -> COMPUTE_PROGRAM_NV;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLProgramTarget");
		};
	}
}