package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLSamplerParameterF implements GLEnum {
	TEXTURE_BORDER_COLOR(0x1004),
	TEXTURE_MIN_LOD(0x813a),
	TEXTURE_MAX_LOD(0x813b),
	TEXTURE_MAX_ANISOTROPY(0x84fe),
	TEXTURE_LOD_BIAS(0x8501),
	TEXTURE_UNNORMALIZED_COORDINATES_ARM(0x8f6a);
	
	private final int glEnum;

	GLSamplerParameterF(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLSamplerParameterF> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLSamplerParameterF fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x1004 -> TEXTURE_BORDER_COLOR;
			case 0x813a -> TEXTURE_MIN_LOD;
			case 0x813b -> TEXTURE_MAX_LOD;
			case 0x84fe -> TEXTURE_MAX_ANISOTROPY;
			case 0x8501 -> TEXTURE_LOD_BIAS;
			case 0x8f6a -> TEXTURE_UNNORMALIZED_COORDINATES_ARM;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLSamplerParameterF");
		};
	}
}