package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLShadingRateCombinerOp implements GLEnum {
	FRAGMENT_SHADING_RATE_COMBINER_OP_KEEP_EXT(0x96d2),
	FRAGMENT_SHADING_RATE_COMBINER_OP_REPLACE_EXT(0x96d3),
	FRAGMENT_SHADING_RATE_COMBINER_OP_MIN_EXT(0x96d4),
	FRAGMENT_SHADING_RATE_COMBINER_OP_MAX_EXT(0x96d5),
	FRAGMENT_SHADING_RATE_COMBINER_OP_MUL_EXT(0x96d6);
	
	private final int glEnum;

	GLShadingRateCombinerOp(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLShadingRateCombinerOp> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLShadingRateCombinerOp fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x96d2 -> FRAGMENT_SHADING_RATE_COMBINER_OP_KEEP_EXT;
			case 0x96d3 -> FRAGMENT_SHADING_RATE_COMBINER_OP_REPLACE_EXT;
			case 0x96d4 -> FRAGMENT_SHADING_RATE_COMBINER_OP_MIN_EXT;
			case 0x96d5 -> FRAGMENT_SHADING_RATE_COMBINER_OP_MAX_EXT;
			case 0x96d6 -> FRAGMENT_SHADING_RATE_COMBINER_OP_MUL_EXT;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLShadingRateCombinerOp");
		};
	}
}