package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLSpecialNumbers implements GLEnum {
	FALSE(0x0),
	TRUE(0x1),
	LUID_SIZE_EXT(0x8),
	UUID_SIZE_EXT(0x10),
	INVALID_INDEX(0xffffffff);
	
	private final int glEnum;

	GLSpecialNumbers(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLSpecialNumbers> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLSpecialNumbers fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x0 -> FALSE;
			case 0x1 -> TRUE;
			case 0x8 -> LUID_SIZE_EXT;
			case 0x10 -> UUID_SIZE_EXT;
			case 0xffffffff -> INVALID_INDEX;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLSpecialNumbers");
		};
	}
}