package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLStencilOp implements GLEnum {
	ZERO(0x0),
	INVERT(0x150a),
	KEEP(0x1e00),
	REPLACE(0x1e01),
	INCR(0x1e02),
	DECR(0x1e03),
	INCR_WRAP(0x8507),
	DECR_WRAP(0x8508);
	
	private final int glEnum;

	GLStencilOp(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLStencilOp> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLStencilOp fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x0 -> ZERO;
			case 0x150a -> INVERT;
			case 0x1e00 -> KEEP;
			case 0x1e01 -> REPLACE;
			case 0x1e02 -> INCR;
			case 0x1e03 -> DECR;
			case 0x8507 -> INCR_WRAP;
			case 0x8508 -> DECR_WRAP;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLStencilOp");
		};
	}
}