package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLSyncCondition implements GLEnum {
	SYNC_GPU_COMMANDS_COMPLETE(0x9117);
	
	private final int glEnum;

	GLSyncCondition(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLSyncCondition> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLSyncCondition fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x9117 -> SYNC_GPU_COMMANDS_COMPLETE;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLSyncCondition");
		};
	}
}