package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLTextureGenMode implements GLEnum {
	EYE_LINEAR(0x2400),
	OBJECT_LINEAR(0x2401),
	SPHERE_MAP(0x2402),
	EYE_DISTANCE_TO_POINT_SGIS(0x81f0),
	OBJECT_DISTANCE_TO_POINT_SGIS(0x81f1),
	EYE_DISTANCE_TO_LINE_SGIS(0x81f2),
	OBJECT_DISTANCE_TO_LINE_SGIS(0x81f3);
	
	private final int glEnum;

	GLTextureGenMode(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLTextureGenMode> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLTextureGenMode fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x2400 -> EYE_LINEAR;
			case 0x2401 -> OBJECT_LINEAR;
			case 0x2402 -> SPHERE_MAP;
			case 0x81f0 -> EYE_DISTANCE_TO_POINT_SGIS;
			case 0x81f1 -> OBJECT_DISTANCE_TO_POINT_SGIS;
			case 0x81f2 -> EYE_DISTANCE_TO_LINE_SGIS;
			case 0x81f3 -> OBJECT_DISTANCE_TO_LINE_SGIS;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLTextureGenMode");
		};
	}
}