package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLTextureWrapMode implements GLEnum {
	CLAMP(0x2900),
	REPEAT(0x2901),
	CLAMP_TO_BORDER(0x812d),
	CLAMP_TO_EDGE(0x812f),
	MIRRORED_REPEAT(0x8370);
	
	private final int glEnum;

	GLTextureWrapMode(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLTextureWrapMode> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLTextureWrapMode fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x2900 -> CLAMP;
			case 0x2901 -> REPEAT;
			case 0x812d -> CLAMP_TO_BORDER;
			case 0x812f -> CLAMP_TO_EDGE;
			case 0x8370 -> MIRRORED_REPEAT;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLTextureWrapMode");
		};
	}
}