package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLVertexArrayPNameAPPLE implements GLEnum {
	STORAGE_CLIENT_APPLE(0x85b4),
	STORAGE_CACHED_APPLE(0x85be),
	STORAGE_SHARED_APPLE(0x85bf);
	
	private final int glEnum;

	GLVertexArrayPNameAPPLE(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLVertexArrayPNameAPPLE> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLVertexArrayPNameAPPLE fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x85b4 -> STORAGE_CLIENT_APPLE;
			case 0x85be -> STORAGE_CACHED_APPLE;
			case 0x85bf -> STORAGE_SHARED_APPLE;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLVertexArrayPNameAPPLE");
		};
	}
}