package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLVertexAttribLType implements GLEnum, IGLVertexAttribPointerType {
	DOUBLE(0x140a);
	
	private final int glEnum;

	GLVertexAttribLType(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLVertexAttribLType> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLVertexAttribLType fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x140a -> DOUBLE;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLVertexAttribLType");
		};
	}

	@Override
	public java.lang.foreign.ValueLayout layout() {
		return switch (this) {
			case DOUBLE -> java.lang.foreign.ValueLayout.JAVA_DOUBLE;
		};
	}
}